package org.elsysbg.xml.dom;

import java.io.File;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class IterateOver {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			DocumentBuilderFactory factory = DocumentBuilderFactory
					.newInstance();
			DocumentBuilder builder = factory.newDocumentBuilder();
			Document document = builder.parse(new File("library.xml"));
			Node firstChild = document.getFirstChild();
			System.out.println("First child is " + firstChild.getNodeName());
			
			iterateOver(document);
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static void iterateOver(Document document) {
		Node child = document.getFirstChild();
		visit(child, "--");
	}

	private static void visit(Node item, final String prefix) {
		System.out.println(prefix+"item: "+item.getNodeName()+ " ("+item.getNodeValue()+")");
		final NodeList nodes = item.getChildNodes();

		for(int i=0;i<nodes.getLength();i++) {
			visit(nodes.item(i), prefix+"--");
		}
		
	}

}
