package org.elsysbg.xml.dom;

import java.io.File;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class NodeRecognizer {

	private static String nodeTypes[] = { "none", "Element", "Attr", "Text",
			"CDATA", "EntityRef", "Entity", "ProcInst", "Comment", "Document",
			"DocType", "DocFragment", "Notation" };

	public static void main(String args[]) {
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		try {
			DocumentBuilder builder = factory.newDocumentBuilder();
			Document document = builder.parse(new File("library.xml"));
			Node firstChild = document.getFirstChild();
			NodeList children = firstChild.getChildNodes();
			for (int i = 0; i < children.getLength(); i++) {
				Node node = children.item(i);
				System.out.println("Node " + node.getNodeName() + " is a/an "
						+ nodeTypes[node.getNodeType()]);
			}
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
